require './lib/redpay/session'

require 'json'
require 'ostruct'

class Refund

  def initialize(app, key, endpoint)
    @app      = app
    @key      = key
    @endpoint = endpoint
  end

  def Process(request)
    json_request = JSON.parse(request.to_json, object_class: OpenStruct)
    # TODO Validate request here

    # Create a session with the server
    session = Session.new(@app, @key, @endpoint + "ecard")

    # Contruct refund packet
    req = 
    {
      "transactionId" => json_request.transactionId,
      "action" => "R",
    }

    return session.Send(req)
  end
  
end